import java.util.Random;
/**
 * Uppgift 4: Siffersummor och delbarhet.
 * 
 * @author Uno Holmer
 * @version 2015-10-20
 */
public class Uppgift4 {
    private static Random rand = new Random();
    // b
    // Om basfallet är n == 0 får 10, 100, 1000, osv siffersumman 2
    // Så vad är egentligen basfallet? 
    // Att talet är noll eller att det är ensiffrigt?
    // Problemet handlar ju om siffror i ett positionssystem
    // så siffersumman i ett ensiffrigt tal är talet självt.
    public static int sifSum(int n) {
        if ( n < 0 )
            return sifSum(-n);
        else if ( n < 10 )  // Är talet ensiffrigt?
            return n;
        else 
            return n%10 + sifSum(n/10);
    }

    // Ett tal är delbart med det ensiffriga talet 1 < k < 10 omm
    // talets siffersumma är delbart med k.
    // "Bevis" genom att söka efter motexempel på att det ena villkoret
    // är uppfyllt, men inte det andra.
    public static void main(String[] arg) {
        for ( int k = 2; k <= 9; k++ ) {
            int antalBrott = 0;
            System.out.println("****** Jobbar med k=" + k + " ******");
            for ( int i = 0; i < 10; i++  ) {
                int tal = rand.nextInt(1000);
                boolean A = tal%k == 0;
                boolean B = sifSum(tal)%k == 0;
                if ( A && ! B ) {
                    antalBrott++;
                    System.out.println("Talet " + tal + " delbart, men inte siffersumman");
                } else if ( !A && B ) {
                    antalBrott++;
                    System.out.println("Talet " + tal + " inte delbart, men siffersumman är det");
                }
            }
            System.out.println("Antal brott: " + antalBrott);
            if ( antalBrott == 0 )
                System.out.println("Bevisat för " + k);
        }
    }
}



















